/*
 * このソースコードは blanco Frameworkによって自動生成されています。
 * Eclipseプラグイン [BlancoDbEE]のウィザードクラス
 */
package blanco.plugin.dbee.wizards;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IProjectNature;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.wizard.Wizard;
import org.eclipse.ui.INewWizard;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.ide.IDE;

import blanco.plugin.dbee.BlancoDbEEPluginConstants;

/**
 * Eclipseプラグイン [BlancoDbEE]のウィザードクラス。
 *
 * blancoDb Enterprise Editionプラグインのソースコード自動生成のための定義書です。<br>
 */
public abstract class AbstractBlancoDbEEWizard extends Wizard implements INewWizard {
    /**
     */
    private ISelection selection;

    /**
     */
    public AbstractBlancoDbEEWizard() {
        super();
        setNeedsProgressMonitor(true);
        setWindowTitle("blancoDb Enterprise Edition Wizard");
    }

    /**
     *
     * @param workbench
     * @param selection
     */
    public void init(final IWorkbench workbench, final IStructuredSelection selection) {
        this.selection = selection;
    }

    /**
     *
     * @return
     */
    public boolean performFinish() {
        // 基本的にチェックはウィザード側で終了していると仮定します。
        IProject proj = getProject(selection);
        if (proj == null) {
            return false;
        }

        // ここで ファイルを新規作成します。
        IFile file = proj.getFile(BlancoDbEEPluginConstants.TARGET_FILENAME);
        doFinish(file);

        IWorkbenchPage page = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage();
        try {
            // エディタを開きます。
            IDE.openEditor(page, file, "blanco.plugin.dbee.editors");
        } catch (PartInitException e) {
            // 例外は無視します。
        }

        return true;
    }

    /**
     */
    public void addPages() {
        final AbstractBlancoDbEEWizardPage page = new BlancoDbEEWizardPage(selection);
        addPage(page);
        final BlancoDbEEWizardPage2 page2 = new BlancoDbEEWizardPage2(selection);
        addPage(page2);
        final BlancoDbEEWizardPage3 page3 = new BlancoDbEEWizardPage3(selection);
        addPage(page3);
        final BlancoDbEEWizardPage4 page4 = new BlancoDbEEWizardPage4(selection);
        addPage(page4);
        final AbstractBlancoDbEEWizardPage99 page99 = new BlancoDbEEWizardPage99(selection);
        addPage(page99);
    }

    /**
     * ISelectionから IProject(プロジェクト)を取得します。
     *
     * @param selection
     * @return
     */
    public static IProject getProject(final ISelection selection) {
        IProject proj = null;
        IStructuredSelection ssel = (IStructuredSelection) selection;
        if (ssel.isEmpty()) {
            return null;
        }
        Object obj = ssel.getFirstElement();
        if (obj instanceof IProjectNature) {
            // プロジェクトの場合には、これが入ってきます。
            IProjectNature nature = (IProjectNature) obj;
            proj = nature.getProject();
        } else if (obj instanceof IResource) {
            IResource res = (IResource) obj;
            proj = res.getProject();
        } else {
            System.out.println(obj.getClass());
            return null;
        }
        return proj;
    }

    /**
     *
     * @param file
     */
    private void doFinish(final IFile file) {
        try {
            InputStream stream = openContentStream();
            if (file.exists()) {
                // なにもしません。
            } else {
                file.create(stream, false, null);
            }
            stream.close();
        } catch (IOException e) {
        } catch (CoreException e) {
            e.printStackTrace();
        }
    }

    /**
     *
     * @return
     */
    private InputStream openContentStream() {
        String contents = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><blanco/>";
        return new ByteArrayInputStream(contents.getBytes());
    }
}
